        TITLE   MAIN

.8086

        INCLUDE SE.ASM

DATA    SEGMENT	WORD PUBLIC
        extrn   ErrorFName:dword,ExitCode:word,ErrorAddr:dword
        extrn   ErrAddr:dword,OldDS:word,OldBP:word
        extrn   ErrorMsgBuf:byte
DATA    ENDS

CODE    SEGMENT BYTE PUBLIC

        ASSUME  cs:CODE,ds:DATA,es:nothing

        public ReportError

; Add string to other string
; In     CS:BX = pointer to sourcestring
; In/Out DI = offset of destination string

AddToConst:
@@2:    mov al, cs:[bx]
        or al, al
        jz @@1
        mov ErrorMsgBuf[di], al
        inc di
        inc bx
        jmp short @@2
@@1:    ret

; Add decimal to string
; In    AX = Number
;       DI = offset of destination string
Dec2Str:xor dx, dx
        mov cx, 100
        div cx
        add al, '0'
        mov ErrorMsgBuf[di], al
        inc di
        mov ax, dx
        aam
        xchg al, ah
        add ax, '00'
        mov word ptr ErrorMsgBuf[di], ax
        inc di
        inc di
        ret

; Add hex to string
; In    AX = Number
;       DI = offset of destination string
Hex2Str:push ax
        xchg ah, al
        call Byt2Str
        pop ax
Byt2Str:aam 16
        xchg ah, al
        call Nib2Str
        xchg ah, al
Nib2Str:add al, '0'
        cmp al, '9'
        jbe Chr2Str
        add al, 'A'-'0'-10
Chr2Str:mov ErrorMsgBuf[di], al
        inc di
        ret

ReportError:
        mov ax, seg DATA
        mov ds, ax
        xor di, di
        mov bx, offset OtherError
        call AddToConst
        mov ax, ExitCode
        call Dec2Str
        jmp short @@B4
@@B4:   mov bx, offset LoppuStr1
        call AddToConst
        mov ax, ErrorAddr.seg
        call Hex2Str
        mov al, ':'
        call Chr2Str
        mov ax, ErrorAddr.ofs
        call Hex2Str
        mov ax, 13
        call Chr2Str
        mov ax, 10
        call Chr2Str
        call AddToConst
        mov bx, offset ErrorMsgBuf
        xor al, al
        mov ErrorMsgBuf[di], al
        retn

; Error strings
OtherError      db 'Error #',0
LoppuStr1       db ' at ',0

CODE    ENDS

        END
