; *******************************************************
; *     CRT Interface Unit                              *
; *******************************************************

        TITLE   CRT

        INCLUDE SE.ASM

.8086

DATA    SEGMENT WORD PUBLIC

; Externals
        extrn CRTLocal : byte ; Table of following:

include crt_save.inc

		IF DPMIVersion
				EXTRN   RealModeRegs:BYTE
		ENDIF

DATA    ENDS

CODE    SEGMENT BYTE PUBLIC

				ASSUME  CS:CODE,DS:DATA

; Publics
				PUBLIC  TextColor,TextBackground
				PUBLIC  LowVideo,HighVideo,NormVideo

; Set text color (color modes)
TextColor:
				MOV     BX,SP
        MOV     AL,SS:[BX+4]
        TEST    AL,0F0H
        JE      @@1
        AND     AL,0FH
        OR      AL,80H
@@1:    AND     TextAttr,70H
        OR      TextAttr,AL
        RETF    2

; Set text background (color modes)
TextBackground:
        MOV     BX,SP
        MOV     AL,SS:[BX+4]
        AND     AL,7
        MOV     CL,4
        SHL     AL,CL
        AND     TextAttr,8FH
        OR      TextAttr,AL
        RETF    2

; Select low intensity
LowVideo:
        AND     TextAttr,0F7H
        RETF

; Select high intensity
HighVideo:
        OR      TextAttr,8
        RETF

; Select normal intensity
NormVideo:
        MOV     AL,NormAttr
        MOV     TextAttr,AL
        RETF

CODE    ENDS

        END
