; *******************************************************
; *                                                     *
; *     Turbo Pascal Runtime Library Version 5.5        *
; *     Program Execution Routines                      *
; *                                                     *
; *******************************************************

        TITLE   EXEC

        LOCALS  @@

        include se.asm

DATA    SEGMENT WORD PUBLIC

        EXTRN   DosError:WORD,PrefixSeg:WORD

SaveSP  DW ?
SaveSS  DW ?

DATA    ENDS

CODE    SEGMENT BYTE PUBLIC

        ASSUME  CS:CODE,DS:DATA

        PUBLIC  Exec, DosExitCode

Exec:   arg PathArg, dword, 1
        arg CmdLineArg, dword, 1
        loc FileSeg2, word, 1
        loc FileOfs2, word, 1
        loc FileSeg1, word, 1
        loc FileOfs1, word, 1
        loc CmdLineSeg, word, 1
        loc CmdLineOfs, word, 1
        loc EnvironSeg, word, 1
        loc FileBlock1, word, 8
        loc FileBlock2, word, 8
        loc Path, byte, 80
        loc CmdLine, byte, 128

        entry sfFar+sfDATADS

        MOV     SaveSP,SP
        MOV     SaveSS,SS

        MOV     DS,PrefixSeg
        MOV     AX,WORD PTR DS:2CH
        MOV     EnvironSeg,AX
        PUSH    SS
        POP     ES
        CLD
        LDS     SI,PathArg
        LEA     DI,Path
        LODSB
        CMP     AL,79
        JB      @@1
        MOV     AL,79
@@1:    CBW
        XCHG    AX,CX
        REP     MOVSB
        XOR     AL,AL
        STOSB
        LDS     SI,CmdLineArg
        LEA     DI,CmdLine
        LODSB
        CMP     AL,126
        JB      @@2
        MOV     AL,126
@@2:    STOSB
        CBW
        XCHG    AX,CX
        REP     MOVSB
        MOV     AL,0DH
        STOSB
        PUSH    SS
        POP     DS
        LEA     SI,CmdLine
        MOV     CmdLineOfs,SI
        MOV     CmdLineSeg,DS
        INC     SI
        LEA     DI,FileBlock1
        MOV     FileOfs1,DI
        MOV     FileSeg1,ES
        MOV     AX,2901H
        INT     21H
        LEA     DI,FileBlock2
        MOV     FileOfs2,DI
        MOV     FileSeg2,ES
        MOV     AX,2901H
        INT     21H
        LEA     DX,Path
        LEA     BX,EnvironSeg
        MOV     AX,4B00H
        INT     21H
        JC      @@3
        XOR     AX,AX
@@3:    MOV     DX,SEG DATA
        MOV     DS,DX
        CLI
        MOV     SP,SaveSP
        MOV     SS,SaveSS
        STI
        MOV     DosError,AX

        exit

DosExitCode:
        MOV     AH,4DH
        INT     21H
        RETF

CODE    ENDS

        END
