; *******************************************************
; *                                                     *
; *     Turbo Pascal Run-time Library                   *
; *     Block Move and Fill Routines                    *
; *                                                     *
; *******************************************************

        TITLE   MEMH

        INCLUDE SE.ASM

CODE    SEGMENT BYTE PUBLIC

        ASSUME  CS:CODE

; Publics
        PUBLIC  MoveMem,FillMem,FillWord

; Move standard procedure
MoveMem:arg SrcPtr,dword,1
        arg DestPtr,dword,1
        arg Count,word,1

        entry far

        push ds
         lds si, SrcPtr
         les di, DestPtr
         mov cx, Count
         CLD
         CMP     SI,DI
         JAE     @@1
         ADD     SI,CX
         ADD     DI,CX
         DEC     SI
         DEC     DI
         STD
@@1:     REP     MOVSB
         CLD
        pop ds
        exit

; FillChar standard procedure
FillMem:MOV     BX,SP
        LES     DI,SS:[BX+8]
        MOV     CX,SS:[BX+6]
        MOV     AL,SS:[BX+4]
        mov ah, al
        CLD
        shr cx, 1
        REP     STOSw
        jnc @@1
        stosb
@@1:    retf 8

; FillWord (standard) procedure
FillWord:MOV    BX,SP
        LES     DI,SS:[BX+8]
        MOV     CX,SS:[BX+6]
        MOV     Ax,SS:[BX+4]
        cld
        rep stosw
        retf 8

CODE    ENDS

        END
